#!/usr/bin/php -q
<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2006 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
   die("<br><strong>This script is only meant to run at the command line.</strong>");
}

/* We are not talking to the browser */
$no_http_headers = true;

$dir = dirname(__FILE__);
chdir($dir);

if (strpos($dir, 'boost') !== false) {
	chdir('../../');
}

/* include important functions */
if (file_exists("./include/global.php")) {
	include_once("./include/global.php");
} else {
	include_once("./include/config.php");
}
include_once($config["base_path"] . "/lib/poller.php");

/* get the boost polling cycle */
$max_run_duration = read_config_option("boost_rrd_update_max_runtime");

/* process calling arguments, first remove the script name */
$parms = $_SERVER["argv"];
array_shift($parms);

/* second, get the socket integer value */
$socket_int_value = $parms[0];
array_shift($parms);

/* last, recombine the arguments */
$command = implode(" ", $parms);

/* execute the command */
if ($config["cacti_server_os"] == "win32") {
	$handle = popen($command, "rb");
}else{
	$handle = popen($command, "r");
}

/* get the results */
$result = fread($handle, 1024);

if (!strlen(trim($result))) {
	$result = "OK";
}else{
	if (substr_count($result, "\r")) {
		$result = str_replace("\r", "", $result);
	}
	$result_array = explode("\n", $result);

	if (sizeof($result_array)) {
		$result = $result_array[sizeof($result_array)-2];
	}else{
		$result = "ERROR: Detected unknown error";
	}
}

/* add the value to the table */
db_execute("INSERT INTO poller_output_boost_processes (sock_int_value, status) VALUES ('" . $socket_int_value . "','" . $result . "')");

/* close the connection */
pclose($handle);

/* return the rrdupdate results */
return $result;

?>