<?php

function plugin_init_boost() {
	global $config, $plugin_hooks, $no_http_header_files;

	$config["boost_version"] = "1.6";
	$plugin_hooks['config_arrays']['boost'] = 'boost_config_arrays';
	$plugin_hooks['config_settings']['boost'] = 'boost_config_settings';
	$plugin_hooks['poller_on_demand']['boost'] = 'boost_poller_on_demand';
	$plugin_hooks['poller_bottom']['boost'] = 'boost_poller_bottom';
	$plugin_hooks['draw_navigation_text']['boost'] = 'boost_draw_navigation_text';
	$plugin_hooks['rrdtool_function_graph_cache_check']['boost'] = 'boost_graph_cache_check';
	$plugin_hooks['rrdtool_function_graph_set_file']['boost'] = 'boost_graph_set_file';
	$plugin_hooks['prep_graph_array']['boost'] = 'boost_prep_graph_array';
	$plugin_hooks['utilities_list']['boost'] = 'boost_utilities_list';
	$plugin_hooks['utilities_action']['boost'] = 'boost_utilities_action';

	$no_http_header_files[] = "poller_boost.php";
	$no_http_header_files[] = "boost_server.php";
}

function boost_draw_navigation_text ($nav) {
	$nav["utilities.php:view_boost_status"] = array("title" => "Boost Status", "mapping" => "index.php:,utilities.php:", "url" => "utilities.php", "level" => "2");
	return $nav;
}

function boost_utilities_action($action) {
	global $config, $colors;

	if ($action == 'view_boost_status') {
		/* ================= input validation ================= */
		input_validate_input_number(get_request_var_request("refresh"));
		/* ==================================================== */

		load_current_session_value("refresh", "sess_boost_utilities_refresh", "30");

		$refresh["seconds"] = $_REQUEST["refresh"];
		$refresh["page"] = "utilities.php?action=view_boost_status";

		include_once($config['base_path'] . "/include/top_header.php");

		boost_display_run_status();

		include_once($config['base_path'] . "/include/bottom_footer.php");

		exit;
	}
}

function boost_file_size_display($file_size, $digits = 2) {
	if ($file_size > 1024) {
		$file_size = round(($file_size / 1024), 0);

		if ($file_size > 1024) {
			$file_size = round(($file_size / 1024), 0);

			if ($file_size > 1024) {
				$file_size = round(($file_size / 1024), 0);
				$file_suffix = " GBytes";
			}else{
				$file_suffix = " MBytes";
			}
		}else{
			$file_suffix = " KBytes";
		}
	}else{
		$file_suffix = " Bytes";
	}

	$file_size = round($file_size, $digits) . $file_suffix;

	return $file_size;
}

function boost_display_run_status() {
	global $colors, $config, $refresh_interval, $boost_utilities_interval, $boost_refresh_interval, $boost_max_runtime;

	$base_start_time = read_config_option("boost_rrd_update_base_time", TRUE);
	$last_run_time   = read_config_option("boost_last_run_time", TRUE);
	$next_run_time   = read_config_option("boost_next_run_time", TRUE);

	$rrd_updates     = read_config_option("boost_rrd_update_enable", TRUE);
	$boost_server    = read_config_option("boost_server_enable", TRUE);
	$boost_cache     = read_config_option("boost_png_cache_enable", TRUE);

	$max_records     = read_config_option("boost_rrd_update_max_records", TRUE);
	$max_runtime     = read_config_option("boost_rrd_update_max_runtime", TRUE);
	$update_interval = read_config_option("boost_rrd_update_interval", TRUE);

	html_start_box("<strong>Boost Status</strong>", "98%", $colors["header"], "1", "center", "");
	?>
	<script type="text/javascript">
	<!--
	function applyStatsRefresh(objForm) {
		strURL = '?action=view_boost_status&refresh=' + objForm.refresh[objForm.refresh.selectedIndex].value;
		document.location = strURL;
	}
	-->
	</script>
	<tr bgcolor="<?php print $colors["panel"];?>">
		<form name="form_boost_utilities_stats" method="post">
		<td>
			<table cellpadding="1" cellspacing="0">
				<tr>
					<td width="100">
						&nbsp;Refresh Interval:
					</td>
					<td width="1">
						<select name="refresh" onChange="applyStatsRefresh(document.form_boost_utilities_stats)">
						<?php
						foreach ($boost_utilities_interval as $key => $interval) {
							print '<option value="' . $key . '"'; if ($_REQUEST["refresh"] == $key) { print " selected"; } print ">" . $interval . "</option>";
						}
						?>
					</td>
					<td>
						&nbsp;<input type="image" src="<?php print $config['url_path']; ?>images/button_refresh.gif" alt="Refresh" border="0" align="absmiddle">&nbsp;
					</td>
				</tr>
			</table>
		</td>
		</form>
	</tr>
	<?php
	html_end_box(TRUE);
	html_start_box("", "98%", $colors["header"], "1", "center", "");

	$boost_records      = db_fetch_cell("SELECT count(*) FROM poller_output_boost");

	$total_data_sources = db_fetch_cell("SELECT count(*) FROM poller_item");

	/* get the boost table status */
	$table_status = db_fetch_assoc("show table status like 'poller_output_boost'");
	$boost_table_status = $table_status[0];

	$boost_status = read_config_option("boost_poller_status", TRUE);
	if (strlen($boost_status)) {
		$boost_status_array = explode(":", $boost_status);

		$boost_status_date = $boost_status_array[1];

		if (substr_count($boost_status_array[0], "complete")) $boost_status_text = "Idle";
		elseif (substr_count($boost_status_array[0], "running"))  $boost_status_text = "Running";
		elseif (substr_count($boost_status_array[0], "abend"))    $boost_status_text = "Crashed";
		elseif (substr_count($boost_status_array[0], "timeout"))  $boost_status_text = "Timed Out";
	}else{
		$boost_status_text = "Never Run";
		$boost_status_date = "";
	}

	$stats_boost = read_config_option("stats_boost", TRUE);
	if (strlen($stats_boost)) {
		$stats_boost_array = explode(" ", $stats_boost);

		$stats_duration = explode(":", $stats_boost_array[0]);
		$boost_last_run_duration = $stats_duration[1];

		$stats_rrds = explode(":", $stats_boost_array[1]);
		$boost_rrds_updated = $stats_rrds[1];
	}else{
		$boost_last_run_duration = "";
		$boost_rrds_updated = "";
	}


	/* get cache directory size/contents */
	$cache_directory = read_config_option("boost_png_cache_directory", TRUE);
	$directory_contents = array();

	if (is_dir($cache_directory)) {
		if ($handle = @opendir($cache_directory)) {
			/* This is the correct way to loop over the directory. */
			while (false !== ($file = readdir($handle))) {
				$directory_contents[] = $file;
			}

			closedir($handle);

			/* get size of directory */
			$directory_size = 0;
			$cache_files = 0;
			if (sizeof($directory_contents)) {
				/* goto the cache directory */
				chdir($cache_directory);

				/* check and fry as applicable */
				foreach($directory_contents as $file) {
					/* only remove jpeg's and png's */
					if ((substr_count(strtolower($file), ".png")) ||
						(substr_count(strtolower($file), ".jpg"))) {
						$cache_files++;
						$directory_size += filesize($file);
					}
				}
			}

			$directory_size = boost_file_size_display($directory_size);
			$cache_files = $cache_files . " Files";
		}else{
			$directory_size = "<strong>WARNING:</strong> Can not open directory";
			$cache_files = "<strong>WARNING:</strong> Unknown";
		}
	}else{
		$directory_size = "<strong>WARNING:</strong> Directory Does NOT Exist!!";
		$cache_files = "<strong>WARNING:</strong> N/A";
	}


	$i = 0;

	/* boost status display */
	html_header(array("Current Boost Status"), 2);

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Boost On Demand Updating:</strong></td><td><strong>" . ($rrd_updates == "" ? "Disabled" : $boost_status_text) . "</strong></td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Total Data Sources:</strong></td><td>" . $total_data_sources . "</td>";

	if ($boost_records > 0) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
		print "<td><strong>Total Boost Records:</strong></td><td>" . $boost_records . "</td>";
	}

	/* boost status display */
	html_header(array("Table Size Estimates"), 2);

	/* tell the user how big the table is */
	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Current Boost Table Size:</strong></td><td>" . boost_file_size_display($boost_table_status["Data_length"],2) . "</td>";

	/* tell the user about the average size/record */
	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Avg Bytes/Record:</strong></td><td>" . (($boost_table_status["Avg_row_length"] == 0) ? "N/A" : boost_file_size_display($boost_table_status["Avg_row_length"],0)) . "</td>";

	/* tell the user about the "Maximum Size" this table can be */
	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Max Allowed Boost Table Size:</strong></td><td>" . boost_file_size_display($boost_table_status["Max_data_length"],2) . "</td>";

	/* tell the user about the estimated records that "could" be held in memory */
	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Estimated Maximum Records:</strong></td><td>" . (($boost_table_status["Avg_row_length"]) ? round($boost_table_status["Max_data_length"]/$boost_table_status["Avg_row_length"],0) : "N/A") . " Records</td>";

	/* boost last runtime display */
	html_header(array("Previous Runtime"), 2);

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td width=200><strong>Last Start Time:</strong></td><td>" . $last_run_time . "</td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td width=200><strong>Last Run Duration:</strong></td><td>" . $boost_last_run_duration . " Seconds</td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td width=200><strong>RRD's Updated:</strong></td><td>" . $boost_rrds_updated . "</td>";

	/* boost runtime display */
	html_header(array("Run Time Configuration"), 2);

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td width=200><strong>Update Frequency:</strong></td><td><strong>" . ($rrd_updates == "" ? "N/A" : $boost_refresh_interval[$update_interval]) . "</strong></td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td width=200><strong>Next Start Time:</strong></td><td>" . $next_run_time . "</td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td width=200><strong>Maximum Records:</strong></td><td>" . $max_records . " Records</td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td width=200><strong>Maximum Allowed Runtime:</strong></td><td>" . $boost_max_runtime[$max_runtime] . "</td>";

	/* boost runtime display */
	html_header(array("Boost Server Details"), 2);

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Server Config Status:</strong></td><td><strong>" . ($boost_server == "" ? "Disabled" : "Enabled") . "</strong></td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Multiprocess Server:</td><td>" . (read_config_option("boost_server_multiprocess", TRUE) == "1" ? "Multiple Process" : "Single Process") . "</strong></td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Update Timeout:</td><td>" . read_config_option("boost_server_timeout", TRUE) . " Seconds</strong></td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Server/Port:</td><td>" . read_config_option("boost_server_hostname", TRUE) . "@" . read_config_option("boost_server_listen_port", TRUE) . "</strong></td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Authorized Update Web Servers:</td><td>" . read_config_option("boost_server_clients", TRUE) . "</strong></td>";

	if (strlen(read_config_option("boost_path_rrdupdate")) && (read_config_option("boost_server_multiprocess") == 1)) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
		print "<td><strong>RRDtool Binary Used:</td><td>" . read_config_option("boost_path_rrdupdate") . "</strong></td>";
	}else{
		form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
		print "<td><strong>RRDtool Binary Used:</td><td>" . read_config_option("path_rrdtool") . "</strong></td>";
	}

	/* boost caching */
	html_header(array("Image Caching"), 2);

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Image Cacing Status:</strong></td><td><strong>" . ($boost_cache == "" ? "Disabled" : "Enabled") . "</strong></td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Cache Directory:</strong></td><td>" . $cache_directory . "</td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Cached Files:</strong></td><td>" . $cache_files . "</td>";

	form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
	print "<td><strong>Cached Files Size:</strong></td><td>" . $directory_size . "</td>";

	html_end_box(TRUE);
}

function boost_utilities_list() {
	global $config, $colors;

	html_header(array("Boost Utilities"), 2); ?>

	<tr bgcolor="#<?php print $colors["form_alternate1"];?>">
		<td class="textArea">
			<p><a href='utilities.php?action=view_boost_status'>View Boost Status</a></p>
		</td>
		<td class="textArea">
			<p>This menu pick allows you to view various boost settings and statistics associated with the current running Boost configuration.</p>
		</td>
	</tr>
	<?php
}

function boost_error_handler($errno, $errmsg, $filename, $linenum, $vars) {
	if (read_config_option("log_verbosity") >= POLLER_VERBOSITY_DEBUG) {
		/* define all error types */
		$errortype = array(
			E_ERROR             => 'Error',
			E_WARNING           => 'Warning',
			E_PARSE             => 'Parsing Error',
			E_NOTICE            => 'Notice',
			E_CORE_ERROR        => 'Core Error',
			E_CORE_WARNING      => 'Core Warning',
			E_COMPILE_ERROR     => 'Compile Error',
			E_COMPILE_WARNING   => 'Compile Warning',
			E_USER_ERROR        => 'User Error',
			E_USER_WARNING      => 'User Warning',
			E_USER_NOTICE       => 'User Notice',
			E_STRICT            => 'Runtime Notice',
			E_RECOVERABLE_ERROR => 'Catchable Fatal Error'
		);

		/* create an error string for the log */
		$err = "ERRNO:'"  . $errno   . "' TYPE:'"    . $errortype[$errno] .
			"' MESSAGE:'" . $errmsg  . "' IN FILE:'" . $filename .
			"' LINE NO:'" . $linenum . "'";

		/* let's ignore some lesser issues */
		if (substr_count($errmsg, "date_default_timezone")) return;
		if (substr_count($errmsg, "Only variables")) return;

		/* log the error to the Cacti log */
		cacti_log("PROGERR: " . $err, false, "BOOST");
	}

	return;
}

function boost_poller_on_demand(&$results) {
	global $config;

	/* suppress warnings */
	error_reporting(0);

	/* install the boost error handler */
	set_error_handler("boost_error_handler");

	$outbuf      = "";
	$sql_prefix  = "INSERT INTO poller_output_boost (local_data_id, rrd_name, time, output) VALUES";
	$sql_suffix  = " ON DUPLICATE KEY UPDATE output=VALUES(output)";
	$overhead    = strlen($sql_prefix) + strlen($sql_suffix);

	if ((read_config_option("boost_rrd_update_enable") == "on") ||
		(read_config_option("boost_rrd_update_system_enable") == "on")) {
		/* turn on the system level updates as that is what dictates "off" */
		if (read_config_option("boost_rrd_update_system_enable") != "on") {
			db_execute("REPLACE INTO settings (name,value)
				VALUES ('boost_rrd_update_system_enable','on')");
		}

		if (sizeof($results)) {
			$i          = 1;
			$out_length = 0;

			foreach($results as $result) {
				if ($i == 1) {
					$delim = " ";
				}else{
					$delim = ", ";
				}

				$outbuf .=
					$delim . "('" .
					$result["local_data_id"] . "','" .
					$result["rrd_name"] . "','" .
					$result["time"] . "','" .
					$result["output"] .	"')";

				$out_length += strlen($outbuf);

				if (($out_length + $overhead) > read_config_option("boost_mysql_string_length")) {
					db_execute($sql_prefix . $outbuf . $sql_suffix);
					$outbuf     = "";
					$out_length = 0;
					$i          = 1;
				}else{
					$i++;
				}
			}

			if (strlen($outbuf)) {
				db_execute($sql_prefix . $outbuf . $sql_suffix);
			}
		}

		$return_value = FALSE;
	}else{
		$return_value = TRUE;
	}

	/* restore original error handler */
	restore_error_handler();

	return $return_value;
}

function boost_graph_cache_check($data) {
	global $config;

	/* include poller processing routinges */
	include_once($config["library_path"] . "/poller.php");

	/* suppress warnings */
	error_reporting(0);

	/* install the boost error handler */
	set_error_handler("boost_error_handler");

	/* process input parameters */
	$local_graph_id = $data['local_graph_id'];
	$rra_id = $data['rra_id'];
	$rrdtool_pipe = $data['rrd_struc'];
	$graph_data_array = $data['graph_data_array'];

	/* if we are just printing the rrd command return */
	if (isset($graph_data_array["print_source"])) {
		/* restore original error handler */
		restore_error_handler();

		return FALSE;
	}

	/* if we want to view the error message, then don't show the cache */
	if ((isset($graph_data_array["output_type"])) &&
		($graph_data_array["output_type"] == RRDTOOL_OUTPUT_STDERR)) {
		/* restore original error handler */
		restore_error_handler();

		return FALSE;
	}

	/* get the information to populate into the rrd files */
	if ((read_config_option("boost_rrd_update_enable") == "on") ||
		(read_config_option("boost_rrd_update_system_enable") == "on")) {
		/* turn on the system level updates as that is what dictates "off" */
		if (read_config_option("boost_rrd_update_system_enable") != "on") {
			db_execute("REPLACE INTO settings (name,value)
				VALUES ('boost_rrd_update_system_enable','on')");
		}

		/* before we make a graph, we need to check for rrd updates and perform them. */
		$local_data_ids = db_fetch_assoc("SELECT DISTINCT
			data_template_rrd.local_data_id
			FROM graph_templates_item
			INNER JOIN data_template_rrd
			ON (graph_templates_item.task_item_id=data_template_rrd.id)
			WHERE graph_templates_item.local_graph_id='$local_graph_id'
			AND data_template_rrd.local_data_id > 0
			ORDER BY graph_templates_item.sequence");

		/* first update the RRD files */
		if (sizeof($local_data_ids)) {
			$updates = 0;
			foreach($local_data_ids as $local_data_id) {
				$updates += boost_process_poller_output($rrdtool_pipe, TRUE, $local_data_id["local_data_id"]);
			}
			if ($updates) {
				/* restore original error handler */
				restore_error_handler();

				return FALSE;
			}
		}
	}

	if (isset($_SESSION["sess_current_timespan"])) {
		$timespan = $_SESSION["sess_current_timespan"];
	}else{
		$timespan = 0;
	}

	/* check the graph cache and use it if it is valid, otherwise turn over to
	 * cacti's graphing fucntions.
	 */
	if ((read_config_option("boost_png_cache_enable")) &&
		(boost_determine_caching_state())) {
		/* if timespan is greater than 1, it is a predefined, if it does not
		 * exist, it is the old fasioned MRTG type graph
		 */
		$cache_directory = read_config_option("boost_png_cache_directory");

		if (strlen($cache_directory)) {
			if (is_dir($cache_directory)) {
				if (is_writable($cache_directory)) {
					if ($rra_id > 0) {
						$cache_file = $cache_directory . "/lgi_" . $data["local_graph_id"] . "_rrai_" . $data["rra_id"];
					}else{
						$cache_file = $cache_directory . "/lgi_" . $data["local_graph_id"] . "_rrai_" . $data["rra_id"] . "_tsi_" . $timespan;
					}

					if (isset($graph_data_array["graph_nolegend"])) {
						$cache_file .= "_thumb.png";
					}else{
						$cache_file .= ".png";
					}

					if (file_exists($cache_file)) {
						$mod_time = filemtime($cache_file);
						$poller_interval = read_config_option("poller_interval");

						if (!isset($poller_interval)) {
							$poller_interval = "300";
						}

						if (($mod_time + $poller_interval) > time()) {
							if ($fileptr = fopen($cache_file, "rb")) {
								$data['return'] = fread($fileptr, filesize($cache_file));
								fclose($fileptr);

								/* restore original error handler */
								restore_error_handler();

								return $data;
							}else{
								if (read_config_option("log_verbosity") >= POLLER_VERBOSITY_DEBUG) {
									cacti_log("Attempting to open cache file '$cache_file' failed");
								}
							}
						}else{
							if (read_config_option("log_verbosity") >= POLLER_VERBOSITY_DEBUG) {
								cacti_log("Boost Cache PNG Expired.  Image '$cache_file' will be recreated");
							}
						}
					}
				}else{
					cacti_log("ERROR: Boost Cache Directory is not writable!  Can not cache images");
				}
			}else{
				cacti_log("ERROR: Boost Cache Directory does not exist! Can not cache images");
			}
		}else{
			cacti_log("ERROR: Boost Cache Directory variable is not set! Can not cache images");
		}
	}

	/* restore original error handler */
	restore_error_handler();

	return FALSE;
}

function boost_prep_graph_array($graph_data_array) {
	/* suppress warnings */
	error_reporting(0);

	/* install the boost error handler */
	set_error_handler("boost_error_handler");

	if (boost_determine_caching_state()) {
		if (!isset($graph_data_array["output_flag"])) {
			if (!isset($graph_data_array["print_source"])) {
				$graph_data_array["output_flag"] = RRDTOOL_OUTPUT_STDOUT;
			}
		}
	}

	/* restore original error handler */
	restore_error_handler();

	return $graph_data_array;
}

function boost_graph_set_file($data) {
	global $config, $boost_sock, $graph_data_array;

	/* suppress warnings */
	error_reporting(0);

	/* install the boost error handler */
	set_error_handler("boost_error_handler");

	if (isset($_SESSION["sess_current_timespan"])) {
		$timespan = $_SESSION["sess_current_timespan"];
	}else{
		$timespan = 0;
	}

	/* check the graph cache and use it if it is valid, otherwise turn over to
	 * cacti's graphing fucntions.
	 */
	if ((read_config_option("boost_png_cache_enable")) &&
		(boost_determine_caching_state())) {
		$cache_directory = read_config_option("boost_png_cache_directory");

		if (strlen($cache_directory)) {
			if (is_dir($cache_directory)) {
				if ($data["rra_id"] > 0) {
					$cache_file = $cache_directory . "/lgi_" . $data["local_graph_id"] . "_rrai_" . $data["rra_id"];
				}else{
					$cache_file = $cache_directory . "/lgi_" . $data["local_graph_id"] . "_rrai_" . $data["rra_id"] . "_tsi_" . $timespan;
				}

				if (isset($graph_data_array["graph_nolegend"])) {
					$cache_file .= "_thumb.png";
				}else{
					$cache_file .= ".png";
				}

				if (is_writable($cache_directory)) {
					/* if the cache file was created in a prior step, save it */
					if (strlen($data["output"]) > 10) {
						if ($fileptr = fopen($cache_file, "w")) {
							fwrite($fileptr, $data["output"], strlen($data["output"]));
							fclose($fileptr);
						}
					}
				}else{
					cacti_log("ERROR: Boost Cache Directory is not writable!  Can not cache images");
				}
			}else{
				cacti_log("ERROR: Boost Cache Directory does not exist! Can not cache images");
			}
		}else{
			cacti_log("ERROR: Boost Cache Directory variable is not set! Can not cache images");
		}
	}

	/* restore original error handler */
	restore_error_handler();
}

/* boost_process_poller_output - grabs data from the 'poller_output' table and feeds the *completed*
     results to RRDTool for processing
   @arg $rrdtool_pipe - the array of pipes containing the file descriptor for rrdtool
   @arg $use_server - determines wether or not the server should be used if enabled
   @arg $local_data_id - if you are using boost, you need to update only an rra id at a time
   @arg $time - the maximum update time to check for */
function boost_process_poller_output($rrdtool_pipe, $use_server = FALSE, $local_data_id = "", $time = "") {
	global $config, $boost_sock, $boost_timeout;

	include_once($config["library_path"] . "/rrd.php");

	/* suppress warnings */
	error_reporting(0);

	/* install the boost error handler */
	set_error_handler("boost_error_handler");

	/* get the request limit */
	$limit = read_config_option("boost_rrd_update_max_records_per_select");

	/* tiny SQL where addendum for boost */
	if (strlen($time)) {
		$sql_where = "WHERE time<='$time'";
	}else{
		$sql_where = "";
	}

	/* crease a temporary table to track boost records to delete */
	db_execute("CREATE TEMPORARY TABLE `rcaston` (
		`local_data_id` mediumint(8) unsigned NOT NULL default '0',
		`rrd_name` varchar(19) NOT NULL default '',
		`time` datetime NOT NULL default '0000-00-00 00:00:00',
		PRIMARY KEY  (`local_data_id`,`rrd_name`,`time`)) ENGINE=MEMORY");

	/* tiny SQL where addendum for boost */
	if (strlen($local_data_id)) {
		if (strlen($sql_where)) {
			$sql_where .= " AND local_data_id='$local_data_id'";
		}else{
			$sql_where = "WHERE local_data_id='$local_data_id'";
		}
	}else{
		$max_local_data_id = db_fetch_cell("SELECT local_data_id
			FROM poller_output_boost
			$sql_where
			ORDER BY local_data_id ASC
			LIMIT $limit,1");

		if (strlen(trim($max_local_data_id))) {
			$new_max = $max_local_data_id - 1;

			if (strlen($sql_where)) {
				$sql_where .= " AND local_data_id<='$new_max'";
			}else{
				$sql_where = "WHERE local_data_id<='$new_max'";
			}
		}
	}

	/* get the records */
	$query_string = "SELECT *
		FROM poller_output_boost
		$sql_where
		ORDER BY local_data_id ASC, time ASC, rrd_name ASC
		LIMIT $limit";

	$results = db_fetch_assoc($query_string);

	if (sizeof($results) > 0) {
		/* open the boost socket connection if applicable */
		if ((read_config_option("boost_server_enable") == "on") &&
			($local_data_id != "") &&
			($use_server)) {
			$boost_timeout = read_config_option("boost_server_timeout");
			$boost_sock = boost_server_connect();

			if ($boost_sock < 0) {
				/* restore original error handler */
				restore_error_handler();

				return 0;
			}
		}

		/* create an array keyed off of each .rrd file */
		$local_data_id = -1;
		$time = -1;
		$outbuf = "";
		$ok_to_delete = TRUE;
		foreach ($results as $item) {
			if ($local_data_id != $item["local_data_id"]) {
				/* update the rrd for the previous local_data_id */
				if (strlen($outbuf)) {
					if (read_config_option("log_verbosity") >= POLLER_VERBOSITY_MEDIUM) {
						cacti_log("NOTE: Updating Local Data Id:'$local_data_id'\n", TRUE, "BOOST");
					}

					$return_value = boost_rrdtool_function_update($local_data_id, $rrd_path, $rrd_tmpl, $initial_time, trim($outbuf), $rrdtool_pipe);
					$outbuf = "";

					/* check return status for delete operation */
					if (trim($return_value) != "OK") {
						cacti_log("WARNING: RRD Update Warning '" . $return_value . "' for Local Data ID '$local_data_id'\n", FALSE, "BOOST");
					}
				}

				/* reset the rrd file path and templates, assume non multi output */
				$rrd_path = boost_get_rrd_filename($item["local_data_id"]);
				$rrd_tmpl = boost_get_rrd_template($item["local_data_id"]);

				$local_data_id  = $item["local_data_id"];
				$time           = strtotime($item["time"]);
				$initial_time   = $time;
				$outbuf         = " " . $time;
				$multi_vals_set = FALSE;
			}

			$value = trim($item["output"]);

			/* perform some 'critical' error checking */
			if (!validate_result($value)) {
				$value = "U";
			}

			if ($time != strtotime($item["time"])) {
				if (strlen($outbuf) > read_config_option("boost_rrd_update_string_length")) {
					if (read_config_option("log_verbosity") >= POLLER_VERBOSITY_MEDIUM) {
						cacti_log("NOTE: Updating Local Data Id:'$local_data_id'\n", TRUE, "BOOST");
					}

					$return_value = boost_rrdtool_function_update($local_data_id, $rrd_path, $rrd_tmpl, $initial_time, trim($outbuf), $rrdtool_pipe);
					$outbuf       = "";

					/* check return status for delete operation */
					if (trim($return_value) != "OK") {
						cacti_log("WARNING: RRD Update Warning '" . $return_value . "' for Local Data ID '$local_data_id'\n", FALSE, "BOOST");
					}
				}
				$outbuf .= " " . strtotime($item["time"]);
				$time    = strtotime($item["time"]);
			}

			/* single one value output */
			if ((is_numeric($value)) || ($value == "U")) {
				$outbuf .= ":" . $value;
			}else{
				/* break out multiple value output to an array */
				$values = explode(" ", $value);

				if (!$multi_vals_set) {
					$rrd_field_names = array_rekey(db_fetch_assoc("SELECT
						data_template_rrd.data_source_name,
						data_input_fields.data_name
						FROM (data_template_rrd,data_input_fields)
						WHERE data_template_rrd.data_input_field_id=data_input_fields.id
						AND data_template_rrd.local_data_id=" . $item["local_data_id"]), "data_name", "data_source_name");

					$rrd_tmpl = "";
				}

				$first_tmpl=1;
				for ($i=0; $i<count($values); $i++) {
					if (preg_match("/^([a-zA-Z0-9_\.-]+):([eE0-9\+\.-]+)$/", $values[$i], $matches)) {
						if (isset($rrd_field_names{$matches[1]})) {
							if (read_config_option("log_verbosity") == POLLER_VERBOSITY_DEBUG) {
								cacti_log("Parsed MULTI output field '" . $matches[0] . "' [map " . $matches[1] . "->" . $rrd_field_names{$matches[1]} . "]" , false, "BOOST");
							}

							if (!$multi_vals_set) {
								if (!$first_tmpl) $rrd_tmpl .= ":";
								$rrd_tmpl .= $rrd_field_names{$matches[1]};
								$first_tmpl=0;
							}

							if ((!is_numeric($matches[2])) && ($matches[2] != 0)) {
								$outbuf .= ":U";
							}else{
								$outbuf .= ":" . $matches[2];
							}
						}
					}
				}

				/* we only want to process the template and gather the fields once */
				$multi_vals_set = TRUE;
			}
		}

		/* process the last rrdupdate if applicable */
		$outbuf = trim($outbuf);
		if (strlen($outbuf)) {
			if (read_config_option("log_verbosity") >= POLLER_VERBOSITY_MEDIUM) {
				cacti_log("NOTE: Updating Local Data Id:'$local_data_id'\n", TRUE, "BOOST");
			}

			$return_value = boost_rrdtool_function_update($local_data_id, $rrd_path, $rrd_tmpl, $initial_time, $outbuf, $rrdtool_pipe);

			/* check return status for delete operation */
			if (trim($return_value) != "OK") {
				cacti_log("WARNING: RRD Update Warning '" . $return_value . "' for Local Data ID '$local_data_id'\n", FALSE, "BOOST");
			}
		}

		/* remove the entries from the table */
		if ($ok_to_delete) {
			reset($results);

			/* initialize variables */
			$sql_prefix = "INSERT INTO `rcaston` (local_data_id, rrd_name, time) VALUES";
			$sql_suffix = " ON DUPLICATE KEY UPDATE local_data_id=VALUES(local_data_id)";
			$sql_part   = "";
			$sql_out    = "";
			$sql_length = 0;
			$sql_overhead = strlen($sql_prefix) + strlen($sql_suffix);

			$max_mysql  = read_config_option("boost_mysql_string_length");

			/* setup records to delete */
			foreach ($results as $item) {
				if ($sql_length == 0) {
					$sql_part .= " ('";
				}else{
					$sql_part .= ", ('";
				}

				$sql_part .= $item["local_data_id"] . "', '" .
					$item["rrd_name"] . "', '" .
					$item["time"] . "')";

				/* keep track of the length the easy way */
				$sql_length += strlen($sql_part);

				/* append the record to the SQL */
				$sql_out .= $sql_part;

				$sql_part = "";

				/* if it's time to write, do so */
				if (($sql_overhead + $sql_length) > $max_mysql) {
					db_execute($sql_prefix . $sql_out . $sql_suffix);

					$sql_length = 0;
					$sql_out    = "";
				}
			}

			/* delete the records in bulk */
			db_execute("DELETE FROM `poller_output_boost`
				USING `poller_output_boost`, `rcaston`
				WHERE rcaston.local_data_id=poller_output_boost.local_data_id
				AND rcaston.rrd_name=poller_output_boost.rrd_name
				AND rcaston.time=poller_output_boost.time");
		}

		/* remove the temporary table */
		db_execute("DROP table `rcaston`");

		/* close the boost server connection, if applicable */
		if ((read_config_option("boost_server_enable") == "on") &&
			($local_data_id != "") &&
			($use_server)) {
			boost_server_disconnect($boost_sock);
		}
	}

	/* restore original error handler */
	restore_error_handler();

	return sizeof($results);
}

function boost_determine_caching_state() {
	if (isset($_REQUEST["action"])) {
		$action = $_REQUEST["action"];
	}else{
		$action = "";
	}

	/* turn off image caching for the following actions */
	if ($action == "properties" ||
		$action == "zoom"       ||
		$action == "edit"       ||
		$action == "graph_edit") {
		$cache = FALSE;
	}else{
		$cache = TRUE;
	}

	if (!isset($_SESSION["custom"])) {
		$custom = FALSE;
	}else{
		$custom = $_SESSION["custom"];
	}

	if (($cache) && (!$custom)) {
		return TRUE;
	}else{
		return FALSE;
	}
}

/* boost_get_rrd_template - pulls the rrd_update template from the database and
     use it for making update decisions for multi-output RRD's
   @arg $local_data_id - the data source to obtain information from */
function boost_get_rrd_template($local_data_id) {
	$ds_names = db_fetch_assoc("SELECT
		data_source_name
		FROM data_template_rrd
		WHERE local_data_id='" . $local_data_id . "'
		ORDER BY data_source_name ASC");

	$poller_item_dss = array_rekey(db_fetch_assoc("SELECT
		rrd_name
		FROM poller_item
		WHERE local_data_id=$local_data_id"), "rrd_name", "rrd_name");

	$rrd_template = "";
	if (sizeof($ds_names)) {
		$i = 1;
		foreach($ds_names as $ds_name) {
			if (in_array($ds_name["data_source_name"], $poller_item_dss)) {
				if ($i == 1) {
					$rrd_template .= $ds_name["data_source_name"];
				}else{
					$rrd_template .= ":" . $ds_name["data_source_name"];
				}

				$i++;
			}
		}
	}

	return(trim($rrd_template));
}

/* boost_get_rrd_filename - pulls the rrd filename from the database.
   @arg $local_data_id - the data source to obtain information from */
function boost_get_rrd_filename($local_data_id) {
	return db_fetch_cell("SELECT DISTINCT rrd_path
		FROM poller_item
		WHERE local_data_id='" . $local_data_id . "'");
}

function boost_rrdtool_function_create($local_data_id, $initial_time, $show_source, $rrd_struc) {
	global $config;
	
	if (file_exists($config["include_path"] . "/global_arrays.php")) {
		include ($config["include_path"] . "/global_arrays.php");
	} else {
		include ($config["include_path"] . "/config_arrays.php");
	}

	$data_source_path = get_data_source_path($local_data_id, true);

	/* ok, if that passes lets check to make sure an rra does not already
	exist, the last thing we want to do is overright data! */
	if ($show_source != true) {
		if (file_exists($data_source_path) == true) {
			return -1;
		}
	}

	/* the first thing we must do is make sure there is at least one
	rra associated with this data source... *
	UPDATE: As of version 0.6.6, we are splitting this up into two
	SQL strings because of the multiple DS per RRD support. This is
	not a big deal however since this function gets called once per
	data source */

	$rras = db_fetch_assoc("select
		data_template_data.rrd_step,
		rra.x_files_factor,
		rra.steps,
		rra.rows,
		rra_cf.consolidation_function_id,
		(rra.rows*rra.steps) as rra_order
		from data_template_data
		left join data_template_data_rra on (data_template_data.id=data_template_data_rra.data_template_data_id)
		left join rra on (data_template_data_rra.rra_id=rra.id)
		left join rra_cf on (rra.id=rra_cf.rra_id)
		where data_template_data.local_data_id=$local_data_id
		and (rra.steps is not null or rra.rows is not null)
		order by rra_cf.consolidation_function_id,rra_order");

	/* if we find that this DS has no RRA associated; get out.  This would
	 * indicate that a data sources has been deleted
	 */
	if (sizeof($rras) <= 0) {
		return false;
	}

	/* back off the initial time to allow updates */
	$initial_time -= 300;

	/* create the "--step" line */
	$create_ds = RRD_NL . "--start " . $initial_time . " --step ". $rras[0]["rrd_step"] . " " . RRD_NL;

	/* query the data sources to be used in this .rrd file */
	$data_sources = db_fetch_assoc("select
		data_template_rrd.id,
		data_template_rrd.rrd_heartbeat,
		data_template_rrd.rrd_minimum,
		data_template_rrd.rrd_maximum,
		data_template_rrd.data_source_type_id
		from data_template_rrd
		where data_template_rrd.local_data_id=$local_data_id");

	/* ONLY make a new DS entry if:
	- There is multiple data sources and this item is not the main one.
	- There is only one data source (then use it) */

	if (sizeof($data_sources) > 0) {
	foreach ($data_sources as $data_source) {
		/* use the cacti ds name by default or the user defined one, if entered */
		$data_source_name = get_data_source_item_name($data_source["id"]);

		$create_ds .= "DS:$data_source_name:" .
			$data_source_types{$data_source["data_source_type_id"]} . ":" .
			$data_source["rrd_heartbeat"] . ":" .
			$data_source["rrd_minimum"] . ":" .
			(empty($data_source["rrd_maximum"]) ? "U" : $data_source["rrd_maximum"]) .
			RRD_NL;
	}
	}

	$create_rra = "";
	/* loop through each available RRA for this DS */
	foreach ($rras as $rra) {
		$create_rra .= "RRA:" . $consolidation_functions{$rra["consolidation_function_id"]} . ":" . $rra["x_files_factor"] . ":" . $rra["steps"] . ":" . $rra["rows"] . RRD_NL;
	}

	if ($show_source == true) {
		return read_config_option("path_rrdtool") . " create" . RRD_NL . "$data_source_path$create_ds$create_rra";
	}else{
		boost_rrdtool_execute("create $data_source_path $create_ds$create_rra", false, RRDTOOL_OUTPUT_STDOUT, $rrd_struc, "BOOST");
	}
}

/* boost_rrdtool_function_update - a re-write of the Cacti rrdtool update command
   specifically designed for bulk updates.
   @arg $local_data_id - the data source to obtain information from
   @arg $rrd_path      - the path to the RRD file
   @arg $rrd_update_template  - the order in which values need to be added
   @arg $rrd_update_values    - values to include in the database
   @arg $rrd_struc - a pipe to the rrdtool command */
function boost_rrdtool_function_update($local_data_id, $rrd_path, $rrd_update_template, $initial_time, &$rrd_update_values, $rrd_struc) {
	/* lets count the number of rrd files processed */
	$rrds_processed = 0;

	/* let's check for deleted Data Sources */
	$valid_entry = TRUE;

	/* create the rrd if one does not already exist */
	if (!file_exists($rrd_path)) {
		$valid_entry = boost_rrdtool_function_create($local_data_id, $initial_time, false, $rrd_struc);
	}

	if ($valid_entry) {
		return boost_rrdtool_execute("update $rrd_path --template $rrd_update_template $rrd_update_values", false, RRDTOOL_OUTPUT_STDOUT, $rrd_struc);
	}else{
		return "OK";
	}
}

function boost_rrdtool_execute($command, $output_to_stdout, $rrd_tool_output_options, $rrd_struc) {
	global $boost_sock;

	$return_value = "";

	if ((read_config_option("boost_server_enable") == "") ||
		($boost_sock == "")) {
		rrdtool_execute($command, $output_to_stdout, $rrd_tool_output_options, $rrd_struc, "BOOST");
		return "OK";
	}else{
		return boost_server_run($command);
	}
}

function boost_server_connect() {
	/* get some information about the server */
	$boost_server = read_config_option("boost_server_hostname");
	$boost_port = read_config_option("boost_server_listen_port");

	/* create a streaming socket, of type TCP/IP */
	$sock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
	socket_set_option($sock, SOL_SOCKET, SO_REUSEADDR, 1);
	socket_bind($sock, 0);

	if (!@socket_connect($sock, $boost_server, $boost_port)) {
		cacti_log("ERROR: Socket Error. Boost server is down.  Contact support immediately!!", false, "BOOST");
		$sock = -1;
	}

	return $sock;
}

function boost_server_run($command) {
	global $boost_sock, $boost_timeout;

	$data = "FAILED";

	if ($boost_sock > 0) {
		socket_set_block($boost_sock);

		$len = strlen($command);
		socket_write($boost_sock, $command);

		$read[] = $boost_sock;

		if ((socket_select($read, $write = NULL, $except = NULL, $boost_timeout) > 0)) {
			$data = @socket_read($boost_sock, 1024);
		}else{
			cacti_log("ERROR: Timeout detected.  Boost server is down.  Contact support immediately!!", true, "BOOST");
			socket_close($boost_sock);
		}
	}

	return trim($data);
}

function boost_server_disconnect($sock) {
	global $eol;

	/* do not display warnings or errors, it messes up rrd graphical output */
	if ($sock > 0) {
		@socket_write($sock, "quit" . $eol , strlen("quit" . $eol));
		@socket_close($sock);
	}
}

function boost_poller_bottom ($output) {
	global $config;
	include_once($config["base_path"] . "/lib/poller.php");

	$command_string = read_config_option("path_php_binary");
	$extra_args = "-q " . $config["base_path"] . "/plugins/boost/poller_boost.php";
	exec_background($command_string, "$extra_args");
}

function boost_version () {
	return array( 'name' 	=> 'boost',
			'version'   => '1.6',
			'longname'  => 'Large Site Performane Booster for Cacti',
			'author'    => 'Larry Adams',
			'homepage'  => 'http://www.cacti.net',
			'email'	    => 'larryjadams@comcast.net',
			'url'       => 'http://cactiusers.org/cacti/versions.php'
			);
}

function boost_config_settings () {
	global $tabs, $settings, $boost_refresh_interval, $boost_max_runtime, $boost_max_records_per_select;

	$tabs["boost"] = "Boost";

	$settings["boost"] = array(
		"boost_hq_header" => array(
			"friendly_name" => "On Demand RRD Update Settings",
			"method" => "spacer",
		),
		"boost_rrd_update_enable" => array(
			"friendly_name" => "Enable On Demand RRD Updating",
			"description" => "Should Boost enable on demand RRD updating in Cacti?  If you disable, this change will not take affect until after the next polling cycle.",
			"method" => "checkbox",
			"default" => ""
		),
		"boost_rrd_update_system_enable" => array(
			"friendly_name" => "System Level RRD Updater",
			"description" => "Before RRD On Demand Update Can be Cleared, a poller run must alway pass",
			"method" => "hidden",
			"default" => ""
		),
		"boost_rrd_update_base_time" => array(
			"friendly_name" => "Base Time to Sequence Updates",
			"description" => "The first RRD update will occur based upon this base time, and will update based upon the update interval selected above.",
			"method" => "textbox",
			"default" => "12:00am",
			"max_length" => "10"
		),
		"boost_rrd_update_interval" => array(
			"friendly_name" => "How Often Should Boost Update All RRD's",
			"description" => "When you enable boost, your RRD files are only updated when they are requested by a user, or when this time period elapses.",
			"default" => "60",
			"method" => "drop_array",
			"default" => "60",
			"array" => $boost_refresh_interval
		),
		"boost_rrd_update_max_records" => array(
			"friendly_name" => "Maximum Records",
			"description" => "If the boost output table exceeds this size, in records, an update will take place.",
			"method" => "textbox",
			"default" => "1000000",
			"max_length" => "20"
		),
		"boost_rrd_update_max_records_per_select" => array(
			"friendly_name" => "Maximum Records Per Pass",
			"description" => "To optimize performance, the boost RRD updater needs to know how many records can be processed at a time.  This setting will limit that number.  This number should be a fraction of the total records, but small enough so that PHP has enough memory to can process the query request.  The default value is 50000.",
			"method" => "drop_array",
			"default" => "50000",
			"array" => $boost_max_records_per_select
		),
		"boost_mysql_string_length" => array(
			"friendly_name" => "Maximum MySQL Insert String",
			"description" => "The maximum length string that MySQL can handle in one insert command.
			This value is typically large.  However, it has been seen in some implementation that this
			number may be limited.  After settings value, please review your Cacti Log to insure that
			all updates are working properly.  Increasing this value will reduce load on MySQL and can
			be as high as 1 mega byte.",
			"method" => "textbox",
			"default" => "64000",
			"max_length" => "20"
		),
		"boost_rrd_update_string_length" => array(
			"friendly_name" => "Update String Length",
			"description" => "When you send the RRDupdate command to RRDtool, insure the command is no longer than this
			many characters.  Some systems, such as Windows 2000 can not handle strings longer than 2048 characters where
			Linux can typically handle 8192 or even larger.  The larger this number, the more efficient RRDtool will be.
			However, too large and boost may break.",
			"method" => "textbox",
			"default" => "2000",
			"max_length" => "20"
		),
		"boost_rrd_update_max_runtime" => array(
			"friendly_name" => "Maximum RRD Update Script Run Time",
			"description" => "The maximum time, in seconds, to allow the boost rrd update process to run before exiting.",
			"method" => "drop_array",
			"default" => "600",
			"array" => $boost_max_runtime
		),
		"boost_srv_header" => array(
			"friendly_name" => "Boost Server Settings",
			"method" => "spacer",
		),
		"boost_server_enable" => array(
			"friendly_name" => "Enable Boost Server",
			"description" => "Should Boost server be used to RRDupdates?  If you do not select, then your web server needs R/W to rra directories.",
			"method" => "checkbox",
			"default" => ""
		),
		"boost_server_effective_user" => array(
			"friendly_name" => "Effective User ID",
			"description" => "This UNIX/LINUX only option allows you to use this users UID to create and otherwise operate on RRD's.  In order to use this, you must also be using the 'posix' module in PHP.  A Boost Server restart is required to enact any changes in this setting.",
			"method" => "textbox",
			"default" => "root",
			"max_length" => "20"
		),
		"boost_server_multiprocess" => array(
			"friendly_name" => "Multiprocess Server",
			"description" => "Do you want the boost server to fork a seprate update process for each boost request?  A Boost Server restart is required to enact any changes in this setting.",
			"method" => "drop_array",
			"default" => "1",
			"array" => array("0" => "No", "1" => "Yes")
		),
		"boost_path_rrdupdate" => array(
			"friendly_name" => "RRDUpdate Path",
			"description" => "If you are using the Multiprocess Boost server, it is best to utilize the 'rrdupdate' binary to update your RRDs.  Specify it's path here.  Otherwise, boost will use the 'rrdtool' binary.",
			"method" => "textbox",
			"default" => "",
			"max_length" => "255"
		),
		"boost_server_hostname" => array(
			"friendly_name" => "Hostname or IP for Boost Server",
			"description" => "The Hostname/IP for the boost server.",
			"method" => "textbox",
			"default" => "localhost",
			"max_length" => "100"
		),
		"boost_server_listen_port" => array(
			"friendly_name" => "TCP Port to Communicate On",
			"description" => "The boost server will listen on this port and the client will talk to this port.  A Boost Server restart is required to enact any changes in this setting.",
			"method" => "textbox",
			"default" => "9050",
			"max_length" => "10"
		),
		"boost_server_timeout" => array(
			"friendly_name" => "Boost Server Timeout",
			"description" => "The timeout, in seconds, that the client should wait on the boost server before giving up.",
			"method" => "textbox",
			"default" => "2",
			"max_length" => "10"
		),
		"boost_server_clients" => array(
			"friendly_name" => "Allowed Web Hosts",
			"description" => "A comma separated list of host IP's allowed to connect to the boost server.",
			"method" => "textbox",
			"default" => "127.0.0.1",
			"max_length" => "512"
		),
		"boost_png_header" => array(
			"friendly_name" => "Image Caching",
			"method" => "spacer",
		),
		"boost_png_cache_enable" => array(
			"friendly_name" => "Enable Image Caching",
			"description" => "Should image caching be enabled?",
			"method" => "checkbox",
			"default" => ""
		),
		"boost_png_cache_directory" => array(
			"friendly_name" => "Location for Image Files",
			"description" => "Specify the location where Boost should place your image files.  These files will be automatically purged by the poller when they expire.",
			"method" => "textbox",
			"max_length" => "255",
			"default" => ""
		),
	);
}

function boost_config_arrays () {
	global $boost_refresh_interval, $boost_max_runtime, $boost_utilities_interval, $boost_max_records_per_select;

	$boost_max_records_per_select = array(
		"10000" => "10,000 Records",
		"20000" => "20,000 Records",
		"30000" => "30,000 Records",
		"50000" => "50,000 Records (Default)",
		"80000" => "80,000 Records",
		"100000" => "100,000 Records",
		"250000" => "250,000 Records",
		"500000" => "500,000 Records");

	$boost_utilities_interval = array(
		"999999" => "Disabled",
		"5"   => "5 Seconds",
		"10"  => "10 Seconds",
		"15"  => "15 Seconds",
		"20"  => "20 Seconds",
		"30"  => "30 Seconds",
		"60"  => "1 Minute",
		"300" => "5 Minutes");

	$boost_refresh_interval = array(
		"10"  => "10 Minutes",
		"20"  => "20 Minutes",
		"30"  => "30 Minutes",
		"60"  => "1 Hour",
		"120" => "2 Hours",
		"240" => "4 Hours",
		"360" => "6 Hours");

	$boost_max_runtime = array(
		"300"  => "5 Minutes",
		"600"  => "10 Minutes",
		"1200" => "20 Minutes",
		"2400" => "40 Minutes",
		"3600" => "1 Hour");
}

?>